precision mediump float;
uniform sampler2D a_TexCoord;
varying vec2 v_TexCoord;

const int blur_size = 4;
const float blur_width = 2.0;
const float contrast = 1.0;
const float brightness = -0.2;
const bool bw = false;

vec4 quickblur(vec2 pos)
{
   vec4 pixval = vec4(0.);
   float csum = 0.;
    
   const int nb = 2*blur_size+1;
   
   for (int y=0; y<nb; y++)
   {
       for (int x=0; x<nb; x++)
       { 
           vec2 ipos = pos + vec2(blur_width*float(x-blur_size)/512.0, blur_width*float(y-blur_size)/512.0);
           pixval+= texture2D(a_TexCoord, ipos);
       }
   }
   return pixval/pow(float(nb), 2.);
}

void main()
{
	vec2 uv = v_TexCoord;
    
    vec4 i = quickblur(uv);
    //vec4 i = maxpic(uv);
    

    gl_FragColor = i;
}



