precision mediump float;
uniform sampler2D a_TexCoord;
varying vec2 v_TexCoord;

vec3 noise(float p){return texture2D(a_TexCoord,vec2(p,.0)).xyz;}
vec3 noise(vec2 p){return texture2D(a_TexCoord, p).xyz;}
vec3 noise(vec3 p){float m = mod(p.z,1.0);float s = p.z-m; float sprev = s-1.0;if (mod(s,2.0)==1.0) { s--; sprev++; m = 1.0-m; };return mix(texture2D(a_TexCoord,p.xy+noise(sprev).yz).xyz,texture2D(a_TexCoord,p.xy+noise(s).yz).xyz,m);}


void main()
{
	vec2 uv = v_TexCoord;
	
	//vec3 color = texture2D(a_TexCoord,uv).xyz;
	vec3 color = vec3(1.0);
	float iGlobalTime = 1.0;
	
	float var_size = 0.66;
	float var_alpha = .8;
	float var_distr = 1.0;
	
	for (float q=.0; q<1.0; q+=.01)
	{
		float i = q;
		vec2 size = vec2(1.00-pow(i,var_distr)*.97) * var_size;
		size.x *= 1024.0/720.0;
		
		vec2 m = mod(uv+noise(q).yz*24.0,size);
		
		vec2 s = uv-m;
		
		vec2 offs = (.2+.6*noise(s*1466.1550+vec2(iGlobalTime*.1)).xy);
		vec2 p = m/size - offs;
		vec3 sample_color = texture2D(a_TexCoord,s + .5*size).xyz;
		
		float alpha = 1.0-(length(p)-.2)*1024.0*length(size)*.5;
		alpha = min(var_alpha,max(.0,alpha));
		color = mix(color,sample_color,alpha);
		
	}

	gl_FragColor = vec4(color,1.0);
}