precision mediump float;
uniform sampler2D a_TexCoord;
varying vec2 v_TexCoord;

float SCurve (float value, float amount, float correction) {

	float curve = 1.0; 

    if (value < 0.5)
    {

        curve = pow(value, amount) * pow(2.0, amount) * 0.5; 
    }
        
    else
    { 	
    	curve = 1.0 - pow(1.0 - value, amount) * pow(2.0, amount) * 0.5; 
    }

    return pow(curve, correction);
}


void main()
{
	vec2 uv = v_TexCoord;
	
    vec4 C = texture2D(a_TexCoord, uv);
   	vec4 A = C; 
    
    	// Writing this as a sort of 'note to self' 
    
    	// Applies an S curve to the image, you can adjust the steepness
    	// of the curve with the control values SCurve(input, steepness, gamma)
    
    	C = vec4(SCurve(C.r, 4.0, 1.0), SCurve(C.g, 3.7, 0.7), SCurve(C.b, 2.6, 0.6), 1.0); 
    
    gl_FragColor = C;
}




