precision mediump float;
uniform sampler2D a_TexCoord;
varying vec2 v_TexCoord;

float s;
void srand(vec2 p){
	s=sin(dot(p,vec2(423.62431,321.54323)));
}
float rand(){
	s=fract(s*32322.65432+0.12333);
	return abs(fract(s));
}
float grad(float t){
	return 6.0*pow(t,5.0)-15.0*pow(t,4.0)+10.0*pow(t,3.0);
}
mat2 rot2d(float a){
	float c=cos(a);
	float s=sin(a);
	return mat2(
		c,-s,
		s, c);
}
#define RES 30.0
vec4 voronoi2d(vec2 p,float t){
	float v=1.0;
	vec4 c;
	
	vec2 xx = vec2(0.025);
	vec2 f=floor(p);
	for(float i=-3.0;i<3.0;i++)
	for(float j=-3.0;j<3.0;j++){
		srand(f+0.01*vec2(i,j)*xx);
		vec2 o;
		o.x=rand();
		o.y=rand();
		o*=rot2d(t*(rand()-0.1));
		float d=distance(p,f+vec2(i,j)*xx);
		if(d<v){
			v=d;
			c=texture2D(a_TexCoord,(f+0.01*vec2(i,j)*xx));
		}
	}
	return c;
}
void main(){
	float t=1.0;
	float r=1.0;
	vec2 s=v_TexCoord;
	//fragColor=texture2D(iChannel0,s);
	gl_FragColor=voronoi2d(s*RES,t);
}



