precision mediump float;

uniform sampler2D a_TexCoord;
varying vec2 v_TexCoord;

const float steps = 2.0;
const float dotsize = 1.0 / steps ;
const float half_step = dotsize / 2.0;


void main(void)
{
    vec2 img    = v_TexCoord * steps;
    vec4 pel    = texture2D( a_TexCoord, img );
    
    vec4 tint;
    
    // Magenta Blue
    // Cyan    Yellow
    int ofs = int(v_TexCoord.x*steps) + int(v_TexCoord.y*steps)*2;
    if    (0 == ofs) {
        tint = vec4(1.0,1.0,0.0,0.0);
    } else if (1 == ofs) {
        tint = vec4(0.0,0.0,1.0,0.0);
    } else if (2 == ofs) {
        tint = vec4(1.0,0.0,1.0,0.0);
    } else { // (3 == ofs)
        tint = vec4(0.0,1.0,1.0,0.0);
    };
    
    float gray  = dot(pel.rgb,
                      vec3(0.3, 0.59, 0.11));
    gl_FragColor = mix( pel, tint, gray );
}

